
/*  A Bison parser, made from parser.yy
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	COMMAND_NOP	257
#define	COMMAND_PUSHCW	258
#define	COMMAND_PUSHCD	259
#define	COMMAND_JMPCW	260
#define	COMMAND_JMPCD	261
#define	COMMAND_CALLCW	262
#define	COMMAND_CALLCD	263
#define	COMMAND_RET	264
#define	COMMAND_IRET	265
#define	COMMAND_HALT	266
#define	COMMAND_CONSW	267
#define	COMMAND_CONSD	268
#define	COMMAND_PUSHR	269
#define	COMMAND_POPR	270
#define	COMMAND_JMPR	271
#define	COMMAND_CALLR	272
#define	COMMAND_IN	273
#define	COMMAND_OUT	274
#define	COMMAND_INC	275
#define	COMMAND_DEC	276
#define	COMMAND_ADD	277
#define	COMMAND_SUB	278
#define	COMMAND_NEG	279
#define	COMMAND_SMUL	280
#define	COMMAND_SDIV	281
#define	COMMAND_SHL	282
#define	COMMAND_SHR	283
#define	COMMAND_SAR	284
#define	COMMAND_AND	285
#define	COMMAND_OR	286
#define	COMMAND_XOR	287
#define	COMMAND_NOT	288
#define	COMMAND_MOV	289
#define	COMMAND_READCW	290
#define	COMMAND_READCD	291
#define	COMMAND_WRITCW	292
#define	COMMAND_WRITCD	293
#define	COMMAND_XSGCW	294
#define	COMMAND_XSGCD	295
#define	COMMAND_XSGCI	296
#define	COMMAND_XSGECW	297
#define	COMMAND_XSGECD	298
#define	COMMAND_XSGECI	299
#define	COMMAND_XECW	300
#define	COMMAND_XECD	301
#define	COMMAND_XNECW	302
#define	COMMAND_XNECD	303
#define	COMMAND_SHLC	304
#define	COMMAND_SHRC	305
#define	COMMAND_SARC	306
#define	COMMAND_CALLCT	307
#define	COMMAND_JMPCT	308
#define	COMMAND_PUSHCT	309
#define	COMMAND_READR	310
#define	COMMAND_WRITR	311
#define	COMMAND_CONSB	312
#define	ASM_db	313
#define	ASM_dw	314
#define	ASM_dd	315
#define	REGIST	316
#define	CONSTNORMAL	317
#define	LABELINDEX	318
#define	STRGINDEX	319
#define	ENDOFLINE	320
#define	COMMA	321
#define	COLON	322
#define	PLUS	323
#define	MINUS	324
#define	MULTIPLY	325
#define	DIVIDE	326
#define	BRACKETOPEN	327
#define	BRACKETCLOSE	328
#define	NEG	329

#line 1 "parser.yy"

#include <stdlib.h>
#include <stdio.h>
#include "../common/binarydefs.hpp"
#include "global.hpp"

void resetparser ()
{
  currentaddress=0;
};

void writeconst8(const uint8 const8)
{
  cm->put8(currentaddress, const8);
  currentaddress++;
};

void writeconst16(const uint16 const16)
{
  cm->put16(currentaddress, const16);
  currentaddress+=2;
};

void writeconst32(const uint32 const32)
{
  cm->put32(currentaddress, const32);
  currentaddress+=4;
};

inline void writeins(const uint16 ins)
{
  if (currentaddress&1) yyerror("code not 16bit aligned");
  writeconst16(ins);
};

void writestring (const string &s)
{
  for (unsigned i=0;i<s.size();i++)
    cm->put8(currentaddress++, s[i]);
};


#line 44 "parser.yy"
typedef union{
  uint8 regist;
  labellist::index_t labelindex;
  strglist::index_t strgindex;
  constlist::index_t constindex;
  constlist::elem::value_t constnormal;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		260
#define	YYFLAG		-32768
#define	YYNTBASE	76

#define YYTRANSLATE(x) ((unsigned)(x) <= 329 ? yytranslate[x] : 93)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     8,    10,    12,    14,    18,    22,    26,
    30,    33,    37,    39,    41,    43,    45,    47,    49,    52,
    55,    58,    61,    64,    67,    69,    71,    73,    78,    83,
    86,    89,    92,    95,   100,   105,   110,   115,   120,   125,
   130,   135,   140,   145,   150,   155,   160,   165,   170,   175,
   180,   187,   194,   201,   208,   215,   222,   229,   236,   243,
   250,   257,   264,   269,   274,   279,   282,   285,   288,   295,
   302,   307,   309,   313,   316,   320,   323,   327,   330,   334,
   336,   340,   342,   346,   348,   352,   354,   356,   358,   360
};

static const short yyrhs[] = {    77,
     0,    76,    77,     0,    84,    66,     0,    66,     0,    63,
     0,    64,     0,    78,    69,    78,     0,    78,    70,    78,
     0,    78,    71,    78,     0,    78,    72,    78,     0,    70,
    78,     0,    73,    78,    74,     0,    78,     0,    78,     0,
    78,     0,    78,     0,    78,     0,     3,     0,     4,    82,
     0,     5,    83,     0,     6,    82,     0,     7,    83,     0,
     8,    82,     0,     9,    83,     0,    10,     0,    11,     0,
    12,     0,    13,    62,    67,    82,     0,    14,    62,    67,
    83,     0,    15,    62,     0,    16,    62,     0,    17,    62,
     0,    18,    62,     0,    19,    62,    67,    62,     0,    20,
    62,    67,    62,     0,    21,    62,    67,    62,     0,    22,
    62,    67,    62,     0,    23,    62,    67,    62,     0,    24,
    62,    67,    62,     0,    25,    62,    67,    62,     0,    26,
    62,    67,    62,     0,    27,    62,    67,    62,     0,    28,
    62,    67,    62,     0,    29,    62,    67,    62,     0,    30,
    62,    67,    62,     0,    31,    62,    67,    62,     0,    32,
    62,    67,    62,     0,    33,    62,    67,    62,     0,    34,
    62,    67,    62,     0,    35,    62,    67,    62,     0,    36,
    62,    67,    62,    67,    82,     0,    37,    62,    67,    62,
    67,    83,     0,    38,    62,    67,    62,    67,    82,     0,
    39,    62,    67,    62,    67,    83,     0,    40,    62,    67,
    62,    67,    82,     0,    41,    62,    67,    62,    67,    83,
     0,    43,    62,    67,    62,    67,    82,     0,    44,    62,
    67,    62,    67,    83,     0,    46,    62,    67,    62,    67,
    82,     0,    47,    62,    67,    62,    67,    83,     0,    48,
    62,    67,    62,    67,    82,     0,    49,    62,    67,    62,
    67,    83,     0,    50,    62,    67,    79,     0,    51,    62,
    67,    79,     0,    52,    62,    67,    79,     0,    53,    81,
     0,    54,    81,     0,    55,    81,     0,    56,    62,    67,
    62,    67,    62,     0,    57,    62,    67,    62,    67,    62,
     0,    58,    62,    67,    80,     0,    85,     0,    59,    86,
    85,     0,    59,    86,     0,    60,    87,    85,     0,    60,
    87,     0,    61,    88,    85,     0,    61,    88,     0,    90,
    67,    86,     0,    90,     0,    89,    67,    86,     0,    89,
     0,    91,    67,    87,     0,    91,     0,    92,    67,    88,
     0,    92,     0,    65,     0,    80,     0,    82,     0,    83,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   143,   144,   147,   148,   151,   152,   153,   154,   155,   156,
   157,   158,   161,   164,   167,   170,   173,   176,   177,   178,
   179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
   189,   190,   191,   192,   194,   196,   198,   200,   202,   204,
   206,   208,   210,   212,   214,   216,   218,   220,   222,   224,
   227,   229,   232,   234,   237,   239,   242,   244,   247,   249,
   252,   254,   257,   259,   261,   263,   265,   267,   269,   271,
   273,   275,   278,   279,   280,   281,   282,   283,   286,   287,
   288,   289,   292,   293,   296,   297,   300,   303,   306,   309
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","COMMAND_NOP",
"COMMAND_PUSHCW","COMMAND_PUSHCD","COMMAND_JMPCW","COMMAND_JMPCD","COMMAND_CALLCW",
"COMMAND_CALLCD","COMMAND_RET","COMMAND_IRET","COMMAND_HALT","COMMAND_CONSW",
"COMMAND_CONSD","COMMAND_PUSHR","COMMAND_POPR","COMMAND_JMPR","COMMAND_CALLR",
"COMMAND_IN","COMMAND_OUT","COMMAND_INC","COMMAND_DEC","COMMAND_ADD","COMMAND_SUB",
"COMMAND_NEG","COMMAND_SMUL","COMMAND_SDIV","COMMAND_SHL","COMMAND_SHR","COMMAND_SAR",
"COMMAND_AND","COMMAND_OR","COMMAND_XOR","COMMAND_NOT","COMMAND_MOV","COMMAND_READCW",
"COMMAND_READCD","COMMAND_WRITCW","COMMAND_WRITCD","COMMAND_XSGCW","COMMAND_XSGCD",
"COMMAND_XSGCI","COMMAND_XSGECW","COMMAND_XSGECD","COMMAND_XSGECI","COMMAND_XECW",
"COMMAND_XECD","COMMAND_XNECW","COMMAND_XNECD","COMMAND_SHLC","COMMAND_SHRC",
"COMMAND_SARC","COMMAND_CALLCT","COMMAND_JMPCT","COMMAND_PUSHCT","COMMAND_READR",
"COMMAND_WRITR","COMMAND_CONSB","ASM_db","ASM_dw","ASM_dd","REGIST","CONSTNORMAL",
"LABELINDEX","STRGINDEX","ENDOFLINE","COMMA","COLON","PLUS","MINUS","MULTIPLY",
"DIVIDE","BRACKETOPEN","BRACKETCLOSE","NEG","program","line","exp","top5","top8",
"top12","top16","top32","command","data","dblist","dwlist","ddlist","strenc",
"dbenc","dwenc","ddenc", NULL
};
#endif

static const short yyr1[] = {     0,
    76,    76,    77,    77,    78,    78,    78,    78,    78,    78,
    78,    78,    79,    80,    81,    82,    83,    84,    84,    84,
    84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
    84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
    84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
    84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
    84,    84,    84,    84,    84,    84,    84,    84,    84,    84,
    84,    84,    85,    85,    85,    85,    85,    85,    86,    86,
    86,    86,    87,    87,    88,    88,    89,    90,    91,    92
};

static const short yyr2[] = {     0,
     1,     2,     2,     1,     1,     1,     3,     3,     3,     3,
     2,     3,     1,     1,     1,     1,     1,     1,     2,     2,
     2,     2,     2,     2,     1,     1,     1,     4,     4,     2,
     2,     2,     2,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     6,     6,     6,     6,     6,     6,     6,     6,     6,     6,
     6,     6,     4,     4,     4,     2,     2,     2,     6,     6,
     4,     1,     3,     2,     3,     2,     3,     2,     3,     1,
     3,     1,     3,     1,     3,     1,     1,     1,     1,     1
};

static const short yydefact[] = {     0,
    18,     0,     0,     0,     0,     0,     0,    25,    26,    27,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     4,     0,     1,
     0,    72,     5,     6,     0,     0,    16,    19,    17,    20,
    21,    22,    23,    24,     0,     0,    30,    31,    32,    33,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    15,    66,    67,    68,     0,     0,     0,    87,
    14,    88,    74,    82,    80,    89,    76,    84,    90,    78,
    86,     2,     3,    11,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    73,     0,     0,    75,
     0,    77,     0,    12,     7,     8,     9,    10,    28,    29,
    34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
    44,    45,    46,    47,    48,    49,    50,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    13,
    63,    64,    65,     0,     0,    71,    81,    79,    83,    85,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    69,    70,     0,     0
};

static const short yydefgoto[] = {    59,
    60,    67,   221,   122,   114,   126,   129,    61,    62,   123,
   127,   130,   124,   125,   128,   131
};

static const short yypact[] = {   249,
-32768,   -44,   -44,   -44,   -44,   -44,   -44,-32768,-32768,-32768,
   -51,   -49,   -37,   -28,   -17,   -13,   -12,   -11,    -9,    -7,
    -6,    -5,    -4,    -2,    41,    44,    62,    63,    64,    66,
    67,    68,    69,    70,    75,    78,    79,    80,    81,    82,
    83,    84,    85,    86,    87,    89,    90,    91,   -44,   -44,
   -44,    92,    93,    94,   -55,   -44,   -44,-32768,    61,-32768,
    57,-32768,-32768,-32768,   -44,   -44,   -33,-32768,   -33,-32768,
-32768,-32768,-32768,-32768,    -8,    95,-32768,-32768,-32768,-32768,
    96,    97,    98,    99,   100,   104,   105,   107,   110,   111,
   112,   114,   115,   116,   117,   118,   119,   120,   121,   122,
   123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
   133,   134,   -33,-32768,-32768,-32768,   135,   136,   137,-32768,
   -33,-32768,   -19,   138,   139,-32768,   -19,   140,-32768,   -19,
   141,-32768,-32768,-32768,   -39,   -44,   -44,   -44,   -44,   -44,
   -44,   147,   148,   149,   150,   151,   152,   153,   154,   155,
   156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
   166,   180,   182,   184,   186,   188,   229,   232,   250,   251,
   -44,   -44,   -44,   252,   254,   -44,-32768,   -55,   -55,-32768,
   -44,-32768,   -44,-32768,   -65,   -65,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   244,   253,   255,
   256,   257,   258,   259,   260,   261,   262,   263,   264,   -33,
-32768,-32768,-32768,   265,   266,-32768,-32768,-32768,-32768,-32768,
   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,
   -44,   -44,   272,   273,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   317,-32768
};

static const short yypgoto[] = {-32768,
   101,    -3,  -150,   -18,   -23,    -1,     9,-32768,  -106,  -135,
   -24,   -22,-32768,-32768,-32768,-32768
};


#define	YYLAST		335


static const short yytable[] = {    69,
    68,    69,    71,    69,    73,   138,   139,    63,    64,   120,
    75,    70,    76,    72,    65,    74,   177,    66,    63,    64,
   180,   222,   223,   182,    77,    65,   115,   116,    66,   136,
   137,   138,   139,    78,   184,   136,   137,   138,   139,    55,
    56,    57,   227,   228,    79,   113,   113,   113,    80,    81,
    82,   121,    83,    69,    84,    85,    86,    87,   140,    88,
   259,   134,   135,     1,     2,     3,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
    38,    39,    89,    40,    41,    90,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,   133,    91,    92,    93,    58,    94,    95,    96,
    97,    98,   185,   186,   187,   188,    99,    69,   189,   100,
   101,   102,   103,   104,   105,   106,   107,   108,   109,   190,
   110,   111,   112,   117,   118,   119,   229,   226,     0,   132,
   230,   141,   142,   143,   144,   145,   146,   220,   220,   220,
   147,   148,   121,   149,   121,   121,   150,   151,   152,    69,
   153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
   163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
   173,   174,   175,   176,   178,   179,   181,   183,   191,   192,
   193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
   203,   204,   205,   206,   207,   208,   209,   210,    69,   245,
    69,   247,    69,   249,    69,   251,    69,   253,    69,   255,
   246,   211,   248,   212,   250,   213,   252,   214,   254,   215,
   256,     1,     2,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
   216,    40,    41,   217,    42,    43,    44,    45,    46,    47,
    48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
   231,   218,   219,   224,    58,   225,   260,     0,     0,   232,
     0,   233,   234,   235,   236,   237,   238,   239,   240,   241,
   242,   243,   244,   257,   258
};

static const short yycheck[] = {     3,
     2,     5,     4,     7,     6,    71,    72,    63,    64,    65,
    62,     3,    62,     5,    70,     7,   123,    73,    63,    64,
   127,   172,   173,   130,    62,    70,    50,    51,    73,    69,
    70,    71,    72,    62,    74,    69,    70,    71,    72,    59,
    60,    61,   178,   179,    62,    49,    50,    51,    62,    62,
    62,    55,    62,    57,    62,    62,    62,    62,    67,    62,
     0,    65,    66,     3,     4,     5,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    62,    43,    44,    62,    46,    47,    48,    49,
    50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
    60,    61,    66,    62,    62,    62,    66,    62,    62,    62,
    62,    62,   136,   137,   138,   139,    62,   141,   140,    62,
    62,    62,    62,    62,    62,    62,    62,    62,    62,   141,
    62,    62,    62,    62,    62,    62,   181,   176,    -1,    59,
   183,    67,    67,    67,    67,    67,    67,   171,   172,   173,
    67,    67,   176,    67,   178,   179,    67,    67,    67,   183,
    67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
    67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
    67,    67,    67,    67,    67,    67,    67,    67,    62,    62,
    62,    62,    62,    62,    62,    62,    62,    62,    62,    62,
    62,    62,    62,    62,    62,    62,    62,    62,   232,   231,
   234,   233,   236,   235,   238,   237,   240,   239,   242,   241,
   232,    62,   234,    62,   236,    62,   238,    62,   240,    62,
   242,     3,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    62,    43,    44,    62,    46,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    67,    62,    62,    62,    66,    62,     0,    -1,    -1,    67,
    -1,    67,    67,    67,    67,    67,    67,    67,    67,    67,
    67,    67,    67,    62,    62
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/misc/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/share/misc/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 5:
#line 151 "parser.yy"
{ yyval.constindex = cl->addVAL(yyvsp[0].constnormal); ;
    break;}
case 6:
#line 152 "parser.yy"
{ yyval.constindex = cl->addLAB(yyvsp[0].labelindex); ;
    break;}
case 7:
#line 153 "parser.yy"
{ yyval.constindex = cl->addADD(yyvsp[-2].constindex,yyvsp[0].constindex); ;
    break;}
case 8:
#line 154 "parser.yy"
{ yyval.constindex = cl->addSUB(yyvsp[-2].constindex,yyvsp[0].constindex); ;
    break;}
case 9:
#line 155 "parser.yy"
{ yyval.constindex = cl->addMUL(yyvsp[-2].constindex,yyvsp[0].constindex); ;
    break;}
case 10:
#line 156 "parser.yy"
{ yyval.constindex = cl->addDIV(yyvsp[-2].constindex,yyvsp[0].constindex); ;
    break;}
case 11:
#line 157 "parser.yy"
{ yyval.constindex = cl->addSUB(cl->addVAL(0),yyvsp[0].constindex); ;
    break;}
case 12:
#line 158 "parser.yy"
{ yyval.constindex = yyvsp[-1].constindex; ;
    break;}
case 13:
#line 161 "parser.yy"
{ yyval.constindex = cl->addTOP5(yyvsp[0].constindex); ;
    break;}
case 14:
#line 164 "parser.yy"
{ yyval.constindex = cl->addTOP8(yyvsp[0].constindex); ;
    break;}
case 15:
#line 167 "parser.yy"
{ yyval.constindex = cl->addTOP12(yyvsp[0].constindex); ;
    break;}
case 16:
#line 170 "parser.yy"
{ yyval.constindex = cl->addTOP16(yyvsp[0].constindex); ;
    break;}
case 17:
#line 173 "parser.yy"
{ yyval.constindex = cl->addTOP32(yyvsp[0].constindex); ;
    break;}
case 18:
#line 176 "parser.yy"
{writeins(0x0000);;
    break;}
case 19:
#line 177 "parser.yy"
{writeins(0x0001);writeconst16(0);cl->get(yyvsp[0].constindex).address=currentaddress-2;;
    break;}
case 20:
#line 178 "parser.yy"
{writeins(0x0002);writeconst32(0);cl->get(yyvsp[0].constindex).address=currentaddress-4;;
    break;}
case 21:
#line 179 "parser.yy"
{writeins(0x0003);writeconst16(0);cl->get(yyvsp[0].constindex).address=currentaddress-2;;
    break;}
case 22:
#line 180 "parser.yy"
{writeins(0x0004);writeconst32(0);cl->get(yyvsp[0].constindex).address=currentaddress-4;;
    break;}
case 23:
#line 181 "parser.yy"
{writeins(0x0005);writeconst16(0);cl->get(yyvsp[0].constindex).address=currentaddress-2;;
    break;}
case 24:
#line 182 "parser.yy"
{writeins(0x0006);writeconst32(0);cl->get(yyvsp[0].constindex).address=currentaddress-4;;
    break;}
case 25:
#line 183 "parser.yy"
{writeins(0x0007);;
    break;}
case 26:
#line 184 "parser.yy"
{writeins(0x0008);;
    break;}
case 27:
#line 185 "parser.yy"
{writeins(0x0009);;
    break;}
case 28:
#line 186 "parser.yy"
{ writeins(uint16(yyvsp[-2].regist)+0x0010);writeconst16(0); cl->get(yyvsp[0].constindex).address=currentaddress-2; ;
    break;}
case 29:
#line 187 "parser.yy"
{ writeins(uint16(yyvsp[-2].regist)+0x0020);writeconst32(0); cl->get(yyvsp[0].constindex).address=currentaddress-4; ;
    break;}
case 30:
#line 188 "parser.yy"
{writeins(uint16(yyvsp[0].regist)+0x0030);;
    break;}
case 31:
#line 189 "parser.yy"
{writeins(uint16(yyvsp[0].regist)+0x0040);;
    break;}
case 32:
#line 190 "parser.yy"
{writeins(uint16(yyvsp[0].regist)+0x0050);;
    break;}
case 33:
#line 191 "parser.yy"
{writeins(uint16(yyvsp[0].regist)+0x0060);;
    break;}
case 34:
#line 193 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0100);;
    break;}
case 35:
#line 195 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0200);;
    break;}
case 36:
#line 197 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0300);;
    break;}
case 37:
#line 199 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0400);;
    break;}
case 38:
#line 201 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0500);;
    break;}
case 39:
#line 203 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0600);;
    break;}
case 40:
#line 205 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0700);;
    break;}
case 41:
#line 207 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0800);;
    break;}
case 42:
#line 209 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0900);;
    break;}
case 43:
#line 211 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0A00);;
    break;}
case 44:
#line 213 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0B00);;
    break;}
case 45:
#line 215 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0C00);;
    break;}
case 46:
#line 217 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0D00);;
    break;}
case 47:
#line 219 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0E00);;
    break;}
case 48:
#line 221 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x0F00);;
    break;}
case 49:
#line 223 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x1000);;
    break;}
case 50:
#line 225 "parser.yy"
{writeins((uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0x1100);;
    break;}
case 51:
#line 228 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<4)+uint16(yyvsp[-2].regist)+0x1200);writeconst16(0);cl->get(yyvsp[0].constindex).address=currentaddress-2;;
    break;}
case 52:
#line 230 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<4)+uint16(yyvsp[-2].regist)+0x1300);writeconst32(0);cl->get(yyvsp[0].constindex).address=currentaddress-4;;
    break;}
case 53:
#line 233 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<4)+uint16(yyvsp[-2].regist)+0x1400);writeconst16(0);cl->get(yyvsp[0].constindex).address=currentaddress-2;;
    break;}
case 54:
#line 235 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<4)+uint16(yyvsp[-2].regist)+0x1500);writeconst32(0);cl->get(yyvsp[0].constindex).address=currentaddress-4;;
    break;}
case 55:
#line 238 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<4)+uint16(yyvsp[-2].regist)+0x1600); writeconst16(0); cl->get(yyvsp[0].constindex).address=currentaddress-2;;
    break;}
case 56:
#line 240 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<4)+uint16(yyvsp[-2].regist)+0x1700);writeconst32(0); cl->get(yyvsp[0].constindex).address=currentaddress-4;;
    break;}
case 57:
#line 243 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<4)+uint16(yyvsp[-2].regist)+0x1800);writeconst16(0); cl->get(yyvsp[0].constindex).address=currentaddress-2;;
    break;}
case 58:
#line 245 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<4)+uint16(yyvsp[-2].regist)+0x1900);writeconst32(0); cl->get(yyvsp[0].constindex).address=currentaddress-4;;
    break;}
case 59:
#line 248 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<4)+uint16(yyvsp[-2].regist)+0x1A00);writeconst16(0); cl->get(yyvsp[0].constindex).address=currentaddress-2;;
    break;}
case 60:
#line 250 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<4)+uint16(yyvsp[-2].regist)+0x1B00);writeconst32(0); cl->get(yyvsp[0].constindex).address=currentaddress-4;;
    break;}
case 61:
#line 253 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<4)+uint16(yyvsp[-2].regist)+0x1C00);writeconst16(0); cl->get(yyvsp[0].constindex).address=currentaddress-2;;
    break;}
case 62:
#line 255 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<4)+uint16(yyvsp[-2].regist)+0x1D00);writeconst32(0); cl->get(yyvsp[0].constindex).address=currentaddress-4;;
    break;}
case 63:
#line 258 "parser.yy"
{writeins(uint16(yyvsp[-2].regist)+0x2000); cl->get(yyvsp[0].constindex).address=currentaddress-2; cl->get(yyvsp[0].constindex).leftshift=4;;
    break;}
case 64:
#line 260 "parser.yy"
{writeins(uint16(yyvsp[-2].regist)+0x2200); cl->get(yyvsp[0].constindex).address=currentaddress-2; cl->get(yyvsp[0].constindex).leftshift=4;;
    break;}
case 65:
#line 262 "parser.yy"
{writeins(uint16(yyvsp[-2].regist)+0x2400); cl->get(yyvsp[0].constindex).address=currentaddress-2; cl->get(yyvsp[0].constindex).leftshift=4;;
    break;}
case 66:
#line 264 "parser.yy"
{writeins(0xA000); cl->get(yyvsp[0].constindex).address=currentaddress-2; cl->get(yyvsp[0].constindex).leftshift=0;;
    break;}
case 67:
#line 266 "parser.yy"
{writeins(0xB000); cl->get(yyvsp[0].constindex).address=currentaddress-2; cl->get(yyvsp[0].constindex).leftshift=0;;
    break;}
case 68:
#line 268 "parser.yy"
{writeins(0xC000); cl->get(yyvsp[0].constindex).address=currentaddress-2; cl->get(yyvsp[0].constindex).leftshift=0;;
    break;}
case 69:
#line 270 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<8)+(uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0xD000);;
    break;}
case 70:
#line 272 "parser.yy"
{writeins((uint16(yyvsp[-4].regist)<<8)+(uint16(yyvsp[-2].regist)<<4)+uint16(yyvsp[0].regist)+0xE000);;
    break;}
case 71:
#line 273 "parser.yy"
{ writeins((uint16(yyvsp[-2].regist)<<8)+0xF000); cl->get(yyvsp[0].constindex).address=currentaddress-1; ;
    break;}
case 87:
#line 300 "parser.yy"
{ writestring(strgl->get(yyvsp[0].strgindex).strg); ;
    break;}
case 88:
#line 303 "parser.yy"
{ cl->get(yyvsp[0].constindex).address=currentaddress; writeconst8(0); ;
    break;}
case 89:
#line 306 "parser.yy"
{ cl->get(yyvsp[0].constindex).address=currentaddress; writeconst16(0); ;
    break;}
case 90:
#line 309 "parser.yy"
{ cl->get(yyvsp[0].constindex).address=currentaddress; writeconst32(0); ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/share/misc/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 311 "parser.yy"
